<!DOCTYPE html>
<html>
<head>
    <title>Sensor Reading</title>
    <script src="https://code.highcharts.com/highcharts.js"></script>
    <script src="https://code.highcharts.com/modules/exporting.js"></script>
    <script src="https://code.highcharts.com/modules/export-data.js"></script><head>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/paho-mqtt/1.0.2/mqttws31.js" type="text/javascript"></script>
</head>

</head>
<body>
    <div id="container"></div>
    <script>
        var mqtt;
        var seriesOptions = [
            {
                name: 'Temperature',
                data: []
            },
            {
                name: 'Humidity',
                data: []
            },
            {
                name: 'Heat Index',
                data: []
            },
            {
                name: 'Soil Moisture',
                data: []
            },
            {
                name: 'Salt',
                data: []
            },
            {
                name: 'Light',
                data: []
            },
            {
                name: 'Battery',
                data: []
            }
        ];

        function onConnect() {
            console.log("Connected to broker");
            mqtt.subscribe("juliesundar/codettes/01");
        }

        function onFailure(message) {
            console.log("Connection Attempt to Host "+host+"Failed");
            setTimeout(MQTTconnect, 2000);
        }

        function onMessageArrived(msg){
            console.log(msg.destinationName+"  "+msg.payloadString);

            var obj = JSON.parse(msg.payloadString);
            var time = (new Date()).getTime();

            seriesOptions[0].data.push([time, obj.temp]);
            seriesOptions[1].data.push([time, obj.humid]);
            seriesOptions[2].data.push([time, obj.heatIndex]);
            seriesOptions[3].data.push([time, obj.soil]);
            seriesOptions[4].data.push([time, obj.salt]);
            seriesOptions[5].data.push([time, obj.light]);
            seriesOptions[6].data.push([time, obj.batt]);

            chart.update({
                series: seriesOptions
            });
        }

        function MQTTconnect() {
            var broker = "192.168.100.5";
            console.log("Connecting to " + broker);
            mqtt = new Paho.MQTT.Client(broker, 1883, "web_" + parseInt(Math.random() * 100, 10));
            var options = {
                timeout: 3,
                onSuccess: onConnect,
                onFailure: onFailure,
            };
            mqtt.onMessageArrived = onMessageArrived;
            mqtt.connect(options);
        }

        var chart = Highcharts.chart('container', {
            chart: {
                type: 'spline',
                events: {
                    load: MQTTconnect
                }
            },
            title: {
                text: 'Sensor Reading'
            },
            xAxis: {
                type: 'datetime',
                tickPixelInterval: 150,
                maxZoom: 20 * 1000
            },
            yAxis: {
                title: {
                    text: 'Reading'
                }
            },
            series: seriesOptions
        });
    </script>
</body>
</html>
